// ###################################################################################################
// Versionning du plugin

// 2.3.0 Plugin fonctionnant pour la version 2.3 de SalomTMF (exigences et tests)
// 3.0.0 Plugin fonctionnant pour la version 3 de SalomTMF
// 3.0.2 Correction de deux anomalies 
// 3.1.0 Intgration des paramtres, des environnements, et des campagnes
// 3.1.1 Optimisation du code et fusion des cellules du modle Excel
// 3.1.2 Ajout des colonnes PJ et liens hypertextes par actions
// 3.1.3 Gestion des descriptions au format HTML (retour chariot dans les feuilles Excel pour les descriptions)
//		 Ajout des pices jointes et URL pour les excutions des tests dans les campagnes 
//		 Possibilit d'associer les tests de la feuille Excel avec les exigences dj prsentes dans SalomTMF
//		 Ajout des valeurs de jeux de donnes dans l'excution des campagnes
//		 Possibilit lors du modle et de l'export, de demander la fusion ou non des cellules de la feuille Excel
//		 Possibilit de saisir les pices jointes par utilisation de chemin relatif par rapport au fichier Excel ou par chemin absolu
//		 Pas de cration des colonnes "script automatique" et "emplacement du script automatique" si les plugins ne sont pas installs
//		 Le caractre _  n'est plus considr comme un sparateur de branches/Exigences
// 		 Correction de l'anomalie de test de prsence des plugins sous Windows XP / Java 6
//		 Possibilit d'importer et d'exporter les commentaires des branches, des familles et des suites de tests.
// 3.1.4 Correction de la possibilit d'importer deux cas de tests ayant le mme nom mais dans deux suites diffrentes.
//		 Correction des anomalies de Null Pointer Exception sur les descriptions lors de l'export
// ###################################################################################################
/*
 SalomeTMF is a Test Management Framework
 * Copyright (C) 2007 EDF / France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @author Jrmie DEFAYE
 *
 * Contact: mikael.marche@rd.francetelecom.com
 */

package salomeTMF_plug.pluginxlsxml;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;
import java.util.Vector;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import org.java.plugin.ExtensionPoint;
import org.java.plugin.Plugin;
import org.java.plugin.PluginDescriptor;
import org.java.plugin.PluginManager;
import org.objectweb.salome_tmf.data.DataConstants;
import org.objectweb.salome_tmf.data.Project;
import org.objectweb.salome_tmf.ihm.IHMConstants;
import org.objectweb.salome_tmf.ihm.tools.Tools;
import org.objectweb.salome_tmf.plugins.IPlugObject;
import org.objectweb.salome_tmf.plugins.core.Admin;
import org.objectweb.salome_tmf.plugins.core.Common;

import salomeTMF_plug.pluginxlsxml.Export.ExportXLSDialog;
import salomeTMF_plug.pluginxlsxml.Import.ImportXLSDialog;
import salomeTMF_plug.pluginxlsxml.Commun.PopUpFormalismeExcel;
import salomeTMF_plug.pluginxlsxml.language.Language;

/**
 * Plugin that can import or export data between SalomeTMF and Excel
 * 
 * @version 1
 */
public class Transformxlsxml extends Plugin implements Common, Admin,
		DataConstants, IHMConstants {

	// SalomeTMF pIhm;
	private boolean isFreezed = false;

	private JMenu testGendocSubMenu = null;

	private JMenu campGendocSubMenu = null;

	private JMenu dataGendocSubMenu = null;

	private JMenu testEchangeDonneesSubMenu = null;

	private JMenu campEchangeDonneesSubMenu = null;

	private JMenu dataEchangeDonneesSubMenu = null;

	private IPlugObject pIPlugObject;

	/**
	 * Plugin that can import or export data between SalomeTMF and Excel
	 * 
	 * @param manager
	 *            Manager
	 * @param descr
	 *            Description
	 */
	public Transformxlsxml(PluginManager manager, PluginDescriptor descr) {
		super(manager, descr);
	}

	/**
	 * see org.java.plugin.Plugin()
	 * 
	 * @throws java.lang.Exception
	 *             Erreur language
	 */
	protected void doStart() throws Exception {
		// no-op
	}

	/**
	 * see org.java.plugin.Plugin()
	 * 
	 * @throws java.lang.Exception
	 *             Erreur Language
	 */
	protected void doStop() throws Exception {
		// no-op
	}

	/**
	 * salome.plugins.core.Common
	 * 
	 * @param pIPlugObject
	 *            Interface Homme Machine
	 */
	public void init(Object pIPlugObject) {
		this.pIPlugObject = (IPlugObject) pIPlugObject;
	}

	/**
	 * salome.plugins.core.Common
	 * 
	 * @return True
	 */
	public boolean isActivableInTestToolsMenu() {
		return true;
	}

	/**
	 * salome.plugins.core.Common
	 * 
	 * @return True
	 */
	public boolean isActivableInCampToolsMenu() {
		return true;
	}

	/**
	 * salome.plugins.core.Common
	 * 
	 * @return True
	 */
	public boolean isActivableInDataToolsMenu() {
		return true;
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @return False
	 */
	public boolean usesOtherUIComponents() {
		return false;
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @param testToolsMenu
	 *            Menu
	 */
	public void activatePluginInTestToolsMenu(JMenu testToolsMenu) {
		testToolsMenu.addSeparator();
		testToolsMenu.add(createJMenu());

	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @param campToolsMenu
	 *            Menu
	 */
	public void activatePluginInCampToolsMenu(JMenu campToolsMenu) {
		campToolsMenu.addSeparator();
		campToolsMenu.add(createJMenu());

	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @param dataToolsMenu
	 *            dataToolsMenu
	 */
	public void activatePluginInDataToolsMenu(JMenu dataToolsMenu) {
		dataToolsMenu.addSeparator();
		dataToolsMenu.add(createJMenu());
	}

	/**
	 * Cre le menu de Salom
	 * 
	 * @return Menu cr
	 */
	public JMenu createJMenu() {

		JMenu xlsxmlSubMenu;
		xlsxmlSubMenu = new JMenu(Language.getInstance()
				.getText("Plugin_Excel"));
		JMenuItem importItem = new JMenuItem(Language.getInstance().getText(
				"Importer_des_donnes__partir_d\'un_fichier_XLS"));
		JMenuItem exportItem = new JMenuItem(Language.getInstance().getText(
				"Exporter_au_format_XLS"));
		JMenuItem modeleItem = new JMenuItem(Language.getInstance().getText(
				"Generer_modele_XLS"));

		modeleItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					new PopUpFormalismeExcel(pIPlugObject);
				} catch (Exception ex) {
					Tools.ihmExceptionView(ex);
				}
			}
		});

		exportItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					new ExportXLSDialog(pIPlugObject);
				} catch (Exception ex) {
					Tools.ihmExceptionView(ex);
				}
			}
		});

		importItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					new ImportXLSDialog(pIPlugObject);
				} catch (Exception ex) {
					Tools.ihmExceptionView(ex);
				}
			}
		});
		xlsxmlSubMenu.add(importItem);
		xlsxmlSubMenu.add(exportItem);
		xlsxmlSubMenu.addSeparator();
		xlsxmlSubMenu.add(modeleItem);
		return xlsxmlSubMenu;
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @return Null
	 */
	public Vector getUsedUIComponents() {
		return null;
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @param uiCompCst
	 *            Nombre
	 */
	public void activatePluginInStaticComponent(Integer uiCompCst) {
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @param uiCompCst
	 *            Nombre
	 */
	public void activatePluginInDynamicComponent(Integer uiCompCst) {
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @return True
	 */
	public boolean isFreezable() {
		return true;
	}

	/**
	 * see salome.plugins.core.Common
	 */
	public void freeze() {
		testGendocSubMenu.setEnabled(false);
		campGendocSubMenu.setEnabled(false);
		dataGendocSubMenu.setEnabled(false);
		isFreezed = true;
	}

	/**
	 * see salome.plugins.core.Common
	 */
	public void unFreeze() {
		testGendocSubMenu.setEnabled(true);
		campGendocSubMenu.setEnabled(true);
		dataGendocSubMenu.setEnabled(true);
		isFreezed = false;
	}

	/**
	 * see salome.plugins.core.Common
	 * 
	 * @return isFreezed
	 */
	public boolean isFreezed() {
		return isFreezed;
	}

	/**
	 * see
	 * org.objectweb.salome_tmf.plugins.core.Admin#activateInSalomeAdmin(java.util.Map)
	 * 
	 * @param commonExtensions
	 *            ExtensionPoint
	 * @param testDriverExtensions
	 *            ExtensionPoint
	 * @param scriptEngineExtensions
	 *            ExtensionPoint
	 * @param bugTrackerExtensions
	 *            ExtensionPoint
	 */
	public void allPluginActived(ExtensionPoint commonExtensions,
			ExtensionPoint testDriverExtensions,
			ExtensionPoint scriptEngineExtensions,
			ExtensionPoint bugTrackerExtensions) {

	}

	// ////////////////////////////// Admin interface
	// ////////////////////////////////////

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.objectweb.salome_tmf.plugins.core.Admin#activateInSalomeAdmin(java.util.Map)
	 */
	/**
	 * Non Javadoc
	 * 
	 * @param adminUIComps
	 *            Map
	 * @param iPlugObject
	 *            IPlugObject
	 */
	public void activateInSalomeAdmin(final Map adminUIComps,
			IPlugObject iPlugObject) {
		// !\\ Pour la frame parent de la fenetre secondaire ->
		// Administarion.ptrFrame
	}

	/**
	 * Non Javadoc
	 * 
	 * @param p
	 *            Project
	 */
	public void onDeleteProject(Project p) {

	}

}
